<?php

/**************************************************************************
Graph Functions
**************************************************************************/

function is_graph_allowed($local_graph_id,$s_sessionKey) {
    if  ( isSessionActive( $s_sessionKey )  )
    {
        $s_sessionKey = getTextEscaped( $s_sessionKey );
        $i_db_userId = getDBValue('UserId','select UserId from plugin_nmidWebService_Mobile_Sessions where Sessionkey="'.$s_sessionKey.'"');
	$current_user = array();
	$current_user["policy_graphs"] = getDBValue('policy_graphs',"select policy_graphs from user_auth where id=" . $i_db_userId);
	$current_user["policy_hosts"] = getDBValue('policy_hosts',"select policy_hosts from user_auth where id=" . $i_db_userId);
	$current_user["policy_graph_templates"] = getDBValue('policy_graph_templates',"select policy_graph_templates from user_auth where id=" . $i_db_userId);

        /* get policy information for the sql where clause */
        $sql_where = get_graph_permissions_sql($current_user["policy_graphs"], $current_user["policy_hosts"], $current_user["policy_graph_templates"]);

	$sql = "select
                graph_templates_graph.local_graph_id as lgid
                from (graph_templates_graph,graph_local)
                left join host on (host.id=graph_local.host_id)
                left join graph_templates on (graph_templates.id=graph_local.graph_template_id)
                left join user_auth_perms on ((graph_templates_graph.local_graph_id=user_auth_perms.item_id and user_auth_perms.type=1 and user_auth_perms.user_id=" . $i_db_userId . ") OR (host.id=user_auth_perms.item_id and user_auth_perms.type=3 and user_auth_perms.user_id=" . $i_db_userId . ") OR (graph_templates.id=user_auth_perms.item_id and user_auth_perms.type=4 and user_auth_perms.user_id=" . $i_db_userId . "))
                where graph_templates_graph.local_graph_id=graph_local.id
                " . (empty($sql_where) ? "" : "and $sql_where") . "
                and graph_templates_graph.local_graph_id=$local_graph_id
                group by graph_templates_graph.local_graph_id";
	$o_result = mysql_query( $sql );
        $graphs = mysql_fetch_assoc( $o_result );
	mysql_free_result( $o_result );

        if ( $graphs['lgid'] > 0) {
                return true;
        }else{
                return false;
        }
    }
}

/* get_graph_permissions_sql - creates SQL that reprents the current graph, host and graph
     template policies
   @arg $policy_graphs - (int) the current graph policy
   @arg $policy_hosts - (int) the current host policy
   @arg $policy_graph_templates - (int) the current graph template policy
   @returns - an SQL "where" statement */
function get_graph_permissions_sql($policy_graphs, $policy_hosts, $policy_graph_templates) {
        $sql = "";
        $sql_or = "";
        $sql_and = "";
        $sql_policy_or = "";
        $sql_policy_and = "";

        if ($policy_graphs == "1") {
                $sql_policy_and .= "$sql_and(user_auth_perms.type != 1 OR user_auth_perms.type is null)";
                $sql_and = " AND ";
                $sql_null = "is null";
        }elseif ($policy_graphs == "2") {
                $sql_policy_or .= "$sql_or(user_auth_perms.type = 1 OR user_auth_perms.type is not null)";
                $sql_or = " OR ";
                $sql_null = "is not null";
        }

        if ($policy_hosts == "1") {
                $sql_policy_and .= "$sql_and((user_auth_perms.type != 3) OR (user_auth_perms.type is null))";
                $sql_and = " AND ";
        }elseif ($policy_hosts == "2") {
                $sql_policy_or .= "$sql_or((user_auth_perms.type = 3) OR (user_auth_perms.type is not null))";
                $sql_or = " OR ";
        }

        if ($policy_graph_templates == "1") {
                $sql_policy_and .= "$sql_and((user_auth_perms.type != 4) OR (user_auth_perms.type is null))";
                $sql_and = " AND ";
        }elseif ($policy_graph_templates == "2") {
                $sql_policy_or .= "$sql_or((user_auth_perms.type = 4) OR (user_auth_perms.type is not null))";
                $sql_or = " OR ";
        }

        $sql_and = "";

        if (!empty($sql_policy_or)) {
                $sql_and = "AND ";
                $sql .= $sql_policy_or;
        }

        if (!empty($sql_policy_and)) {
                $sql .= "$sql_and$sql_policy_and";
        }

        if (empty($sql)) {
                return "";
        }else{
                return "(" . $sql . ")";
        }
}


/**
 * Graph retrieval function
 * @param string $s_sessionKey
 * @param string $i_lgid
 * @param string $i_start
 * @param string $i_end
 * @param string $i_height
 * @param string $i_width
 * @param string $i_nolegend
 * @return string
 */
function getGraph ( $s_sessionKey,$i_lgid,$i_start,$i_end,$i_height,$i_width, $i_nolegend )
{
    // make the parameters "secure"
    $i_lgid = getNumber( $i_lgid );
    $i_start = getNumber( $i_start );
    $i_end = getNumber( $i_end );
    $i_height = getNumber( $i_height );
    $i_width = getNumber( $i_width );
    $i_nolegend = getNumber( $i_nolegend );
    if  ( ( isSessionActive( $s_sessionKey ) ) && ( is_graph_allowed($i_lgid,$s_sessionKey) ) )
    {
                // create the temporary graph image name
                $s_imgname = tempnam('tmp/',$i_lgid.'_');
                if ( $s_imgname == true ) {
                        // create the image
			 $php_binary = readConfigOption( "path_php_binary");

                        system($php_binary . " create_image.php ". $i_lgid ." 0 ". $i_start ." ". $i_end ." ". $i_height ." ". $i_width ." ".$i_nolegend." > ". $s_imgname );
			$command = $php_binary . " create_image.php ". $i_lgid ." 0 ". $i_start ." ". $i_end ." ". $i_height ." ". $i_width ." ".$i_nolegend;
                        $tmp_image = @ImageCreateFromPNG ($s_imgname);

                        $width = imagesx($tmp_image);
                        $height = imagesy($tmp_image);
                        
                        $new_image = imagecreatetruecolor($i_width,$i_height); 
                        ImageCopyResampled($new_image, $tmp_image,0,0,0,0, $i_width, $i_height, $width, $height); 
                        imagealphablending ( $new_image, FALSE );
                        imagepng($new_image, $s_imgname);                        
		 		
                        // open the freshly created image and read its content
                        $h_handle = fopen( $s_imgname, "rb" );
                        $s_contents = fread( $h_handle, filesize( $s_imgname ) );
                        fclose( $h_handle );

                        // delete the temporary file
                        unlink( $s_imgname );

                        // return the image as a base64 encoded string
                        return base64_encode( $s_contents );
                }
                else {
			$h_handle = fopen("access_error.png", "rb");
		        $s_contents = fread( $h_handle, filesize( "access_error.png" ) );
		        fclose( $h_handle );

        		return base64_encode( $s_contents );
                }
    }
    else
    {
	$h_handle = fopen("access_denied.png", "rb");
	$s_contents = fread( $h_handle, filesize( "access_denied.png" ) );
	fclose( $h_handle );

	return base64_encode( $s_contents );
    }
}


?>
